/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 */

#ifndef	_ADR_NAME_H
#define	_ADR_NAME_H

#include <sys/types.h>

#ifdef	__cplusplus
extern "C" {
#endif

typedef struct adr_name adr_name_t;

adr_name_t *adr_name_create(const char *, int, const char * const *,
    const char * const *);
adr_name_t *adr_name_vcreate(const char *, int, ...);
adr_name_t *adr_name_fromstr(const char *);
adr_name_t *adr_name_fromstr_x(const char *, boolean_t);

adr_name_t *adr_name_compose(const adr_name_t *, int, const char * const *,
    const char * const *);
adr_name_t *adr_name_vcompose(const adr_name_t *, int, ...);

const char *adr_name_domain(const adr_name_t *);
const char *adr_name_key(const adr_name_t *, const char *);

char *adr_name_tostr(const adr_name_t *);
int adr_name_cmp(const adr_name_t *, const adr_name_t *);
boolean_t adr_name_match(const adr_name_t *, const adr_name_t *);

adr_name_t *adr_name_hold(adr_name_t *);
void adr_name_rele(adr_name_t *);

#ifdef	__cplusplus
}
#endif

#endif	/* _ADR_NAME_H */
