/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 */

#ifndef	_RADCLIENT_H
#define	_RADCLIENT_H

#include <rpc/xdr.h>
#include <rad/adr.h>
#include <rad/adr_object.h>
#include <rad/adr_stream.h>

#ifdef	__cplusplus
extern "C" {
#endif

typedef struct rc_conn rc_conn_t;
typedef struct rc_object rc_object_t;
typedef int rc_err_t;

type_t *rc_type(rc_object_t *, const char *);
type_t *rc_arraytype(rc_object_t *, type_t *);

rc_conn_t *rc_connect(adr_stream_t *);
rc_conn_t *rc_connect_fd(int);
void rc_disconnect(rc_conn_t *);

void rc_set_threaded(rc_conn_t *, boolean_t);
void rc_thread(rc_conn_t *);

rc_err_t rc_list(rc_conn_t *, data_t **, data_t **);
rc_err_t rc_lookup(rc_conn_t *, adr_name_t *, rc_object_t **, data_t **);
rc_err_t rc_lookup_typed(rc_conn_t *, adr_name_t *, rc_object_t **,
    adr_object_t *, data_t **);

rc_err_t rc_invoke(rc_object_t *, const char *, data_t **, data_t **, int,
    data_t **);
rc_err_t rc_set(rc_object_t *, const char *, data_t **, data_t *);
rc_err_t rc_get(rc_object_t *, const char *, data_t **, data_t **);
void rc_release(rc_object_t *);

#ifdef	__cplusplus
}
#endif

#endif	/* _RADCLIENT_H */
